      SUBROUTINE PDGESV1( TRANS, N, NRHS, A, IA, JA, DESCA, IPIV,
     $                    B, IB, JB, DESCB, INFO )
*
* Scalar Arguments
      CHARACTER          TRANS
      INTEGER            IA, IB, INFO, JA, JB, N, NRHS
*
* Array Arguments
      INTEGER            DESCA( * ), DESCB( * ), IPIV( * )
      DOUBLE PRECISION   A( * ), B( * )
*
* Parameters
      INTEGER            BLOCK_CYCLIC_2D, CSRC_, CTXT_, DLEN_, DTYPE_,
     $                   LLD_, MB_, M_, NB_, N_, RSRC_, NOUT
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                     CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                     RSRC_ = 7, CSRC_ = 8, LLD_ = 9, NOUT = 6 )
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
* Local Scalars
      LOGICAL            NOTRAN
      INTEGER            IAROW, IBROW,
     $                   ICOFFA, ICOFFB, ICTXT, IDUMM,
     $                   IROFFA, IROFFB,
     $                   MYCOL, MYROW, NP, NPCOL, NPROW
*
* Local Arrays
      INTEGER            IDUM1( 1 ), IDUM2( 1 )
*
* External Subroutines
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT,
     $                   PDGETRF, PDGETRS, PXERBLA
*     ..
* External Functions
      LOGICAL            LSAME
      INTEGER            ICEIL, ILCM, INDXG2P, NUMROC
      EXTERNAL           ICEIL, ILCM, INDXG2P, LSAME, NUMROC
*     ..
* Intrinsic Functions
      INTRINSIC          DBLE, ICHAR, MOD
*     ..
* Executable Statements
*
* Get grid parameters
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* Test the input parameters
*
      INFO = 0
*
      IF( NPROW.EQ.-1 ) THEN
         INFO = -(700+CTXT_)
      ELSE
*
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 7, INFO )
*
         CALL CHK1MAT( N, 2, NRHS, 3, IB, JB, DESCB, 12, INFO )
*
         NOTRAN = LSAME( TRANS, 'N' )
*
         IF( INFO.EQ.0 ) THEN
            IAROW = INDXG2P( IA, DESCA( MB_ ), MYROW, DESCA( RSRC_ ),
     $                       NPROW )
            IBROW = INDXG2P( IB, DESCB( MB_ ), MYROW, DESCB( RSRC_ ),
     $                       NPROW )
            IROFFA = MOD( IA-1, DESCA( MB_ ) )
            ICOFFA = MOD( JA-1, DESCA( NB_ ) )
            IROFFB = MOD( IB-1, DESCB( MB_ ) )
            ICOFFB = MOD( JB-1, DESCB( NB_ ) )
*
            IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND.
     $         .NOT. LSAME( TRANS, 'C' ) ) THEN
               INFO = -1
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -5
            ELSE IF( ICOFFA.NE.0 .OR. IROFFA.NE.ICOFFA ) THEN
               INFO = -6
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -(700+NB_)
            END IF
         END IF
*
         IF( INFO.EQ.0 ) THEN
            IF( IBROW.NE.IAROW ) THEN
               INFO = -10
            ELSE IF( DESCB( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -(1200+NB_)
            ELSE IF( ICTXT.NE.DESCB( CTXT_ ) ) THEN
               INFO = -(1200+CTXT_)
            END IF
*
            IDUM1( 1 ) = ICHAR( TRANS )
            IDUM2( 1 ) = 1
*
               CALL PCHK2MAT( N, 2, N, 2, IA, JA, DESCA, 7, N, 2,
     $                        NRHS, 3, IB, JB, DESCB, 12, 1, IDUM1,
     $                        IDUM2, INFO )
*
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'PDGESV1', -INFO )
         RETURN
      END IF
*
* Compute the LU factorization of A.
*
         CALL PDGETRF( N, N, A, IA, JA, DESCA, IPIV, INFO )
*
* Return if INFO is non-zero.
*
         IF( INFO.NE.0 ) THEN
            RETURN
         END IF
*
* Compute the solution matrix X.
*
      CALL PDGETRS( TRANS, N, NRHS, A, IA, JA, DESCA, IPIV, B, IB,
     $              JB, DESCB, INFO )
*
      RETURN
*
*     End of PDGESV1
      END
